"""Parses a file with ftp links and returns
a list with ftp infos. 

"""
import re
import urlparse
import htmllib
import formatter

pattern1=re.compile("(?:(?P<user>.*):(?P<pass>.*)@)(?P<host>.*):(?P<port>\d*)")
pattern2=re.compile("(?:(?P<user>.*):(?P<pass>.*)@)(?P<host>.*)")
pattern3=re.compile("(?P<host>.*):(?P<port>\d*)")
pattern4=re.compile("(?P<host>.*)")

def parseftplinkfile(filename=r'E:\test\ftps.html'):
    """Opens file 'filename' and parses it for for urls.
    For every url it finds it calls spliturl and appends
    the result to a list which it returns.
    """
    parser=htmllib.HTMLParser(formatter.NullFormatter())
    parser.feed(open(filename).read())
    parser.close()
    ftplist=[]
    for url in parser.anchorlist:
        ftpentry=spliturl(url)
        if ftpentry:
            ftplist.append(ftpentry)
    return ftplist

def spliturl(url):
    """Splits a url of the format ftp://user:passw@host:port/path
    into a tuple (host,int(port),user,passw,path)
    if the url is not the right format it returns None
    """
    splittedurl=urlparse.urlsplit(url)
    if splittedurl[0].upper()=='FTP':   ##if url in the format ftp://...
        path=splittedurl[2]             ## ftp://mittelteil/path
        if path=="":
            path='/'
        elif path[-1] != '/': path=path+'/'
        mittelteil=splittedurl[1]
        m=pattern1.match(mittelteil)
        if not m:
            m= pattern2.match(mittelteil)
            if not m:
                m= pattern3.match(mittelteil)
                if not m:
                    m= pattern4.match(mittelteil)
        host=m.group('host')
        if m.groupdict().has_key('port'):
            port=m.group('port')
        else:
            port=21
        if m.groupdict().has_key('user'):
            user=m.group('user')
        else:
            user='anonymous'
        if m.groupdict().has_key('pass'):
            passw=m.group('pass')
        else:
            passw='anononymous@asdfhost.com'
        try:
            intport=int(port)
        except ValueError:
            intport=21
        return (host,intport,user,passw,path)
    else :
        return None
       