#!/usr/bin/python
import timeoutsocket
import ftplibpatch as ftplib
import ls2stat
import time, sys, os, traceback, cPickle, Queue, threading, getopt
import CompatMysqldb
es=CompatMysqldb.MySQL.escape_string
from ftpconfig import *

timeoutsocket.setDefaultSocketTimeout(connecttimeout)  #  timeout when connecting

verbose = 0


class Ftpwalk:
    def __init__(self,host,port=21,user='anonymous',passwd='anonymous@host.com',startingdir='/',deep=defaultlevel):
        self.host=host
        self.port=port
        self.user=user
        self.passwd=passwd
        self.startingdir=startingdir
        self.deep=deep
        self.currentlevel=0

        
    def __parsedir(self):
        """get current directory contents and split it in dirs and files"""
        ls=[]
        try:
            self.ftp.retrlines('LIST -a',ls.append)
            #parsels=ftpparse.ftpparse(ls)
        except ftplib.all_errors:
            pass
        parsels=ls2stat.ls2stat(ls)
        dirs= [x for x in parsels.keys() if not(x in [".",".."]) and (parsels[x][ls2stat.stat_modeLetter] in "dl" )]
        files=[(x,parsels[x][ls2stat.stat_size]) for x in parsels.keys() if not(x in [".",".."]) and (parsels[x][ls2stat.stat_modeLetter] == "-") ]
        return (dirs,files)

    def __lastchar(self,dir):
        if dir[-1]=='/':
            return ''
        else:
            return '/'
        
    def walk(self,dir,filelist,dirlist):    
        try:
            self.ftp.cwd(dir)  ##try to change to directory
        except ftplib.all_errors:
            return -1
        self.currentlevel += 1  ##one level deeper... 
        dirs, files = self.__parsedir()  ##sort directory contents in files and dirs
        dirs=[dir+self.__lastchar(dir)+curdir for curdir in dirs]  ## append current path in front of every dir
        files=[(dir+self.__lastchar(dir)+curfile[0],curfile[1]) for curfile in files] ##same for files
        #dirs2=[(dir,0) for dir in dirs]
        if (self.currentlevel<=self.deep):   ##stop if level too deep
            dirs2=[(curdir,self.walk(curdir,filelist,dirlist)) for curdir in dirs] ##crawl every dir and
                    ##save dirname and size of the dir in dirs2
            dirs2=filter(lambda b: b[1]!=-1,dirs2) ##filter out every non dir (where cwd(dir) failed)
        else:
            dirs2=[(dir,0) for dir in dirs] ##if level too deep just say size of dir is 0
        size=0
        for file in files: size += file[1]
        for dir in dirs2:  size +=  dir[1]    ##calculate the sum of all size's in current dir
        dirlist.extend(dirs2)
        filelist.extend(files)
        self.currentlevel -=1
        return size
        
    def ftpwalk(self):
        self.ftp=ftplib.FTP()
        if verbose==1: self.ftp.set_debuglevel(2)
        self.ftp.connect(self.host,self.port)
        self.ftp.login(self.user,self.passwd)
        self.ftp.sock.set_timeout(datatimeout)
        if self.port==21: self.ftp.set_pasv(0)
        else: self.ftp.set_pasv(1)        
        filelist=[]
        dirlist=[]
        size=self.walk(self.startingdir,filelist,dirlist)
        dirlist.append((self.startingdir,size))
        self.ftp.close()
        return (filelist,dirlist,size)

def sqltime():
    return time.strftime("%Y-%m-%d %H:%M:%S")
def pythontime(zeit):
    return time.localtime(time.mktime((int(zeit[:4]),int(zeit[5:7]),int(zeit[8:10]),int(zeit[11:13]),int(zeit[14:16]),int(zeit[17:19]),1,1,-1)))

def writefile(filelist,dirlist,id,times):
    db.execute("DELETE FROM files WHERE (id='%s')" % id)
    templist=[]
    for (file,filesize) in filelist:
        dirnam=os.path.dirname(file)
        if dirnam[-1] != '/': dirnam=dirnam+'/'
        #db.execute('INSERT into files (id,path,file,size) VALUES ("%s","%s","%s","%s")' % \
        #           (id,es(dirnam),es(os.path.basename(file)),filesize/1024))
        templist.append((id,es(dirnam),es(os.path.basename(file)),filesize/1024))
    for (file,filesize) in dirlist:
        if file[-1] != '/': file=file+'/'
        #db.execute('INSERT into files (id,path,file,size) VALUES ("%s","%s","%s","%s")' % (id,es(file),'',filesize/1024))
        templist.append((id,es(file),'',filesize/1024))
    if templist:
        db.execute('INSERT into files (id,path,file,size) VALUES '+",".join(map(lambda (a,b,c,d):'("%s","%s","%s","%s")' % (a,b,c,d),templist)))
    firsttime,lasttime,timesfailure,timessuccess,stats,size=times
    timesfailure=0
    stats='ok'
    timessuccess+=1
    writestats(id,(firsttime,lasttime,timesfailure,timessuccess,stats,size))
    

def writestats(id,times):
    if times[-1]==-1:
        db.execute('DELETE from servers WHERE id="%s"' % id)
        db.execute('DELETE from files WHERE id="%s"' % id)
    else:
        db.execute("UPDATE servers SET firsttime='%s',lasttime='%s',timesfailure='%s',timessuccess='%s',stats='%s',size='%s' WHERE (id='%s')" % (times+(id,)))

def ftpwalkwrap(key):
    """the thread that steps through a site"""
    
    fhost,fport,fuser,fpass,fdir,id=key[:6]
    times=key[6:]
    firsttime,lasttime,timesfailure,timessuccess,stats,size=times
    if firsttime=='0000-00-00 00:00:00': firsttime=sqltime()
    lasttime=sqltime()
    
    try :
        ftpwalkobject=Ftpwalk(fhost,fport,fuser,fpass,fdir)
        filelist,dirlist,size = ftpwalkobject.ftpwalk()
        size = size / 1024
        lock.acquire()
        try:
            if not(filelist) or (len(dirlist)==1) or (size==0):  #evtl nur size==0
                stats='empty'
                dirlist=[]
            writefile(filelist,dirlist,id,(firsttime,lasttime,timesfailure,timessuccess,stats,size))
        finally:
            lock.release()
    except (ftplib.all_errors,timeoutsocket.Timeout):
        timesfailure += 1
        stats='notok'
        if timesfailure>15:
            if timessuccess==0:
                size = -1  #  delete entry
            else:
                if timesfailure>25:
                    size = -1  #  delete entry
        lock.acquire()
        try:
            writestats(id,(firsttime,lasttime,timesfailure,timessuccess,stats,size))
        finally:
            lock.release()
            
    except:
        lock.acquire()
        try:
            errorlog=open("error.log","a")
            errorlog.write(time.asctime())
            errorlog.write(str(key))
            traceback.print_exc(file=errorlog)
            errorlog.close()
            timesfailure += 1
            stats='notok'

            writestats(id,(firsttime,lasttime,timesfailure,timessuccess,stats,size))
        finally:
            lock.release()
            
    q.get()



def usage():
    print """ftpindex.py usage:
    -h, --help     Show this help
    -t, --threads= Max number of threads.   Default is 50.
    -m, --mode=    Change mode to one of:
            all    Scan all servers.
            new    Scan only new servers.
            failed Scan only servers which could not be scanned last time.
    -r, --retries= Set the number of retries to get a listing of a server. 
    		   Default is 3.
    -v, --verbose  Print commands send to servers. 
            
    """
# MAIN PROGRAM

try:
    opts, args = getopt.getopt(sys.argv[1:], "htmrv:", ["help", "threads=","mode=","retries=","verbose"])
except getopt.GetoptError:
    # print help information and exit:
    usage()
    sys.exit(2)

mode="none"
for o, a in opts:
    if o in ("-h", "--help"):
        usage()
        sys.exit()
    if o in ("-t", "--threads"):
        maxthreads = int(a)
    if o in ("-m","--mode"):
        if a in ("new","all","failed"):
            mode=a
    if o in ("-r","--retries"):
        retries=int(a)
    else:
        retries=3
    if o in ("-v","--verbose"):
        verbose=1
    else:
        verbose=0
if mode=="none":
    usage()
    sys.exit()

print "threads:", maxthreads
print "mode:", mode
print "retries:", retries

    
q=Queue.Queue(maxthreads)
lock = threading.Lock()
count=0
conn=CompatMysqldb.mysqldb(database)
db=conn.cursor()


where=""




zeit=sqltime()
if mode=="new":
    where="WHERE (stats='notchecked')"
elif mode=="all":
    where=""
elif mode=="failed":
    where="WHERE (stats='notok')"
    
db.execute("SELECT host,port,user,pass,path,id,firsttime,lasttime,timesfailure,timessuccess,stats,size FROM servers "+where)
ftpservers=db.fetchall()
numberofservers=len(ftpservers)
togo=numberofservers

for i in ftpservers:
    q.put('-')
    togo -= 1
    threading.Thread(target=ftpwalkwrap,args=(i,)).start()
    print togo,"of",numberofservers,"still left"

for retry in range(retries):
    zeit2=sqltime()
    lock.acquire()
    try:        
        db.execute("SELECT host,port,user,pass,path,id,firsttime,lasttime,timesfailure,timessuccess,stats,size FROM servers where (stats='notok') and (lasttime>='%s')" % zeit)
        ftpservers=db.fetchall()
        numberofservers=len(ftpservers)
        togo=numberofservers
    finally:
        lock.release()
    for i in ftpservers:
        q.put('-')
        togo-=1
        threading.Thread(target=ftpwalkwrap,args=(i,)).start()
        print togo,"of",numberofservers,"still left - retry #",retry
        zeit=zeit2


for i in range(maxthreads): q.put('-')
#db.execute('DELETE ')

db.close()
conn.close()